        name    util
        page    55,80
;
        title   'UTILS - Assembly Language utilities'
;
; UTILS.ASM  -- Assembly Language utilities.
;  Copywrite (c) 1998, Michael Radwick, N8XKZ
;
_TEXT   segment word public 'CODE'
        assume cs:_TEXT, ds:_TEXT, es:_TEXT, ss:_TEXT

        PUBLIC atoi, xtoi, strcmp
;
; atoi - Convert zero terminated ascii string to an integer
;
; This function converts an string to an signed integer.
;
; At Entry:
;       SI: points to zero-terminated ascii string to convert
;
; At Exit:
;       AX: Converted integer.
;
atoi    proc near
        mov     ax,0
        mov     dx,0
        mov     cx,10
        mov     cs:signFlg,al
        mov     dl,[si]
        cmp     dl,'+'
        je      skipSign
        cmp     dl,'-'
        jne     atoi1
        mov     cs:signFlg,1
skipSign:
        inc     si
atoi1:
        mov     dl,[si]         ;get the input character
        cmp     dl,0
        je      atoi_done       ;exit if end-of-string
        cmp     dl,'0'
        jl      atoi_done
        cmp     dl,'9'
        jg      atoi_done
        sub     dl,'0'          ;convert to binary
        push    dx              ;multiply accumulated value by 10
        mul     cx
        pop     dx
        add     ax,dx           ;add the new digit
        inc     si              ;point to next character
        jmp     atoi1           ;repeat
;
atoi_done:
        mov     dl,cs:signFlg
        or      dl,dl
        jz      atoi_ret
        neg     ax
atoi_ret:
        ret
;
signFlg db      0

atoi    endp

xtoi    proc near
        mov     ax,0
        mov     dx,0
        mov     cx,4
xtoi1:  
        mov     dl,[si]         ;get the input character
        cmp     dl,0
        je      xtoi_done       ;exit if end-of-string
        cmp     dl,'0'
        jl      xtoi_done       ;exit if character is not hexidecimal
        cmp     dl,'9'
        jle     xtoi2
        cmp     dl,'A'
        jl      xtoi_done
        cmp     dl,'F'
        jg      xtoi_done
        sub     dl,'A'-10       ;convert A-F to binary
        jmp     xtoi3
;
xtoi2:                          ;convert 0-9 to binary
        sub     dl,'0'
xtoi3:
        shl     ax,cl           ;store new nibble
        or      ax,dx
        inc     si              ;point to next character
        jmp     xtoi1
xtoi_done:
        ret
;
xtoi    endp

;
; strcmp - compare two strings for equality
;
; At entry:
;       SI: points to string a
;       DI: points to string b
;
; At Exit:
;       PSW flags set for a == b, a > b, a < b
;
strcmp  proc near
strcmp1:
        mov     al,[si]
        mov     ah,[di]
        inc     si
        inc     di
        cmp     al,0
        je      strcmp_adone
        cmp     ah,0
        je      strcmp_bdone
        cmp     al,ah
        je      strcmp1
        ret
strcmp_adone:
        neg     ah
        ret
strcmp_bdone:
        add     al,0
        ret
;
strcmp  endp

_TEXT   ends

        end

